searchNodes=[{"ref":"JSON.html","title":"JSON","type":"module","doc":"Provides a RFC 7159, ECMA 404, and JSONTestSuite compliant JSON Encoder / Decoder"},{"ref":"JSON.html#decode/1","title":"JSON.decode/1","type":"function","doc":"Converts a valid JSON string into an Elixir term Examples iex&gt; JSON.decode(&quot;{\\&quot;result\\&quot;:\\&quot;this will be an Elixir result\\&quot;}&quot;) {:ok, Enum.into([{&quot;result&quot;, &quot;this will be an Elixir result&quot;}], Map.new)}"},{"ref":"JSON.html#decode!/1","title":"JSON.decode!/1","type":"function","doc":"Converts a valid JSON string into an Elixir term, raises errors when something bad happens Examples iex&gt; JSON.decode!(&quot;{\\&quot;result\\&quot;:\\&quot;this will be an Elixir result\\&quot;}&quot;) Enum.into([{&quot;result&quot;, &quot;this will be an Elixir result&quot;}], Map.new)"},{"ref":"JSON.html#encode/1","title":"JSON.encode/1","type":"function","doc":"Returns a JSON string representation of the Elixir term Examples iex&gt; JSON.encode([result: &quot;this will be a JSON result&quot;]) {:ok, &quot;{\\&quot;result\\&quot;:\\&quot;this will be a JSON result\\&quot;}&quot;}"},{"ref":"JSON.html#encode!/1","title":"JSON.encode!/1","type":"function","doc":"Returns a JSON string representation of the Elixir term, raises errors when something bad happens Examples iex&gt; JSON.encode!([result: &quot;this will be a JSON result&quot;]) &quot;{\\&quot;result\\&quot;:\\&quot;this will be a JSON result\\&quot;}&quot;"},{"ref":"JSON.Decoder.html","title":"JSON.Decoder","type":"protocol","doc":"Defines the protocol required for converting raw JSON into Elixir terms"},{"ref":"JSON.Decoder.html#decode/1","title":"JSON.Decoder.decode/1","type":"function","doc":"Returns an atom and an Elixir term"},{"ref":"JSON.Decoder.html#t:t/0","title":"JSON.Decoder.t/0","type":"type","doc":""},{"ref":"JSON.Decoder.DefaultImplementations.html","title":"JSON.Decoder.DefaultImplementations","type":"module","doc":""},{"ref":"JSON.Decoder.Error.html","title":"JSON.Decoder.Error","type":"exception","doc":"Thrown when an unknown decoder error happens"},{"ref":"JSON.Decoder.UnexpectedEndOfBufferError.html","title":"JSON.Decoder.UnexpectedEndOfBufferError","type":"exception","doc":"Thrown when the json payload is incomplete"},{"ref":"JSON.Decoder.UnexpectedTokenError.html","title":"JSON.Decoder.UnexpectedTokenError","type":"exception","doc":"Thrown when the json payload is invalid"},{"ref":"JSON.Decoder.UnexpectedTokenError.html#message/1","title":"JSON.Decoder.UnexpectedTokenError.message/1","type":"function","doc":"Invalid JSON - Unexpected token"},{"ref":"JSON.Encoder.html","title":"JSON.Encoder","type":"protocol","doc":"Defines the protocol required for converting Elixir types into JSON and inferring their json types."},{"ref":"JSON.Encoder.html#encode/1","title":"JSON.Encoder.encode/1","type":"function","doc":"Returns a JSON string representation of the Elixir term Examples iex&gt; JSON.Encoder.encode({1, :two, &quot;three&quot;}) {:ok, &quot;[1,\\&quot;two\\&quot;,\\&quot;three\\&quot;]&quot;} iex&gt; JSON.Encoder.encode([result: &quot;this will be a elixir result&quot;]) {:ok, &quot;{\\&quot;result\\&quot;:\\&quot;this will be a elixir result\\&quot;}&quot;} iex&gt; JSON.Encoder.encode(%{a: 1, b: 2}) {:ok, &quot;{\\&quot;a\\&quot;:1,\\&quot;b\\&quot;:2}&quot;}"},{"ref":"JSON.Encoder.html#typeof/1","title":"JSON.Encoder.typeof/1","type":"function","doc":"Returns an atom that reprsents the JSON type for the term Examples iex&gt; JSON.Encoder.typeof(3) :number iex&gt; JSON.Encoder.typeof({1, :two, &quot;three&quot;}) :array iex&gt; JSON.Encoder.typeof([foo: &quot;this will be a elixir result&quot;]) :object iex&gt; JSON.Encoder.typeof([result: &quot;this will be a elixir result&quot;]) :object iex&gt; JSON.Encoder.typeof([&quot;this will be a elixir result&quot;]) :array iex&gt; JSON.Encoder.typeof([foo: &quot;bar&quot;]) :object"},{"ref":"JSON.Encoder.html#t:t/0","title":"JSON.Encoder.t/0","type":"type","doc":""},{"ref":"JSON.Encoder.Error.html","title":"JSON.Encoder.Error","type":"exception","doc":"Thrown when an encoder error happens"},{"ref":"JSON.Encoder.Error.html#message/1","title":"JSON.Encoder.Error.message/1","type":"function","doc":"Invalid Term"},{"ref":"JSON.Encoder.Helpers.html","title":"JSON.Encoder.Helpers","type":"module","doc":"Helper functions for JSON.Encoder"},{"ref":"JSON.Encoder.Helpers.html#dict_encode/1","title":"JSON.Encoder.Helpers.dict_encode/1","type":"function","doc":"Given an enumerable that yields tuples of {key, value} encode the enumerable as an object."},{"ref":"JSON.Encoder.Helpers.html#enum_encode/1","title":"JSON.Encoder.Helpers.enum_encode/1","type":"function","doc":"Given an enumerable encode the enumerable as an array."},{"ref":"JSON.Logger.html","title":"JSON.Logger","type":"module","doc":"Exposes separate log level configuration so developers can set logging verbosity for json library To configure log level only for json library, add folowing line in config file use Mix.Config # to make json be very verbose config :json, log_level: :debug # to make json be silent config :json, log_level: :error"},{"ref":"JSON.Logger.html#allowed_levels/0","title":"JSON.Logger.allowed_levels/0","type":"function","doc":""},{"ref":"JSON.Logger.html#log/2","title":"JSON.Logger.log/2","type":"macro","doc":"Logs given message to logger at given log level Supported log levels are: :debug - All messages are logged :info - only :info, :warn and :error messages are logged :warn - only :warn and :error messages are logged :error - only :error messages are logged"},{"ref":"JSON.Parser.html","title":"JSON.Parser","type":"module","doc":"Implements a JSON Parser for Bitstring values"},{"ref":"JSON.Parser.html#parse/1","title":"JSON.Parser.parse/1","type":"function","doc":"parses a valid JSON value, returns its elixir representation Examples iex&gt; JSON.Parser.parse &quot;&quot; {:error, :unexpected_end_of_buffer} iex&gt; JSON.Parser.parse &quot;face0ff&quot; {:error, {:unexpected_token, &quot;face0ff&quot;}} iex&gt; JSON.Parser.parse &quot;-hello&quot; {:error, {:unexpected_token, &quot;-hello&quot;}} iex&gt; JSON.Parser.parse &quot;129245&quot; {:ok, 129245, &quot;&quot;} iex&gt; JSON.Parser.parse &quot;7.something&quot; {:ok, 7, &quot;.something&quot;} iex&gt; JSON.Parser.parse &quot;-88.22suffix&quot; {:ok, -88.22, &quot;suffix&quot;} iex&gt; JSON.Parser.parse &quot;-12e4and then some&quot; {:ok, -1.2e+5, &quot;and then some&quot;} iex&gt; JSON.Parser.parse &quot;7842490016E-12-and more&quot; {:ok, 7.842490016e-3, &quot;-and more&quot;} iex&gt; JSON.Parser.parse &quot;null&quot; {:ok, nil, &quot;&quot;} iex&gt; JSON.Parser.parse &quot;false&quot; {:ok, false, &quot;&quot;} iex&gt; JSON.Parser.parse &quot;true&quot; {:ok, true, &quot;&quot;} iex&gt; JSON.Parser.parse &quot;\\&quot;7.something\\&quot;&quot; {:ok, &quot;7.something&quot;, &quot;&quot;} iex&gt; JSON.Parser.parse &quot;\\&quot;-88.22suffix\\&quot; foo bar&quot; {:ok, &quot;-88.22suffix&quot;, &quot; foo bar&quot;} iex&gt; JSON.Parser.parse &quot;\\&quot;star -&gt; \\\\u272d &lt;- star\\&quot;&quot; {:ok, &quot;star -&gt; ✭ &lt;- star&quot;, &quot;&quot;} iex&gt; JSON.Parser.parse &quot;[]&quot; {:ok, [], &quot;&quot;} iex&gt; JSON.Parser.parse &quot;[\\&quot;foo\\&quot;, 1, 2, 1.5] lala&quot; {:ok, [&quot;foo&quot;, 1, 2, 1.5], &quot; lala&quot;} iex&gt; JSON.Parser.parse &quot;{\\&quot;result\\&quot;: \\&quot;this will be a elixir result\\&quot;} lalal&quot; {:ok, Enum.into([{&quot;result&quot;, &quot;this will be a elixir result&quot;}], Map.new), &quot; lalal&quot;}"},{"ref":"JSON.Parser.Array.html","title":"JSON.Parser.Array","type":"module","doc":"Implements a JSON Array Parser for Bitstring values"},{"ref":"JSON.Parser.Array.html#parse/1","title":"JSON.Parser.Array.parse/1","type":"function","doc":"parses a valid JSON array value, returns its elixir list representation Examples iex&gt; JSON.Parser.Array.parse &quot;&quot; {:error, :unexpected_end_of_buffer} iex&gt; JSON.Parser.Array.parse &quot;[1, 2 &quot; {:error, :unexpected_end_of_buffer} iex&gt; JSON.Parser.Array.parse &quot;face0ff&quot; {:error, {:unexpected_token, &quot;face0ff&quot;}} iex&gt; JSON.Parser.Array.parse &quot;[] lala&quot; {:ok, [], &quot; lala&quot;} iex&gt; JSON.Parser.Array.parse &quot;[]&quot; {:ok, [], &quot;&quot;} iex&gt; JSON.Parser.Array.parse &quot;[\\&quot;foo\\&quot;, 1, 2, 1.5] lala&quot; {:ok, [&quot;foo&quot;, 1, 2, 1.5], &quot; lala&quot;}"},{"ref":"JSON.Parser.Number.html","title":"JSON.Parser.Number","type":"module","doc":"Implements a JSON Numeber Parser for Bitstring values"},{"ref":"JSON.Parser.Number.html#parse/1","title":"JSON.Parser.Number.parse/1","type":"function","doc":"parses a valid JSON numerical value, returns its elixir numerical representation Examples iex&gt; JSON.Parser.Number.parse &quot;&quot; {:error, :unexpected_end_of_buffer} iex&gt; JSON.Parser.Number.parse &quot;face0ff&quot; {:error, {:unexpected_token, &quot;face0ff&quot;}} iex&gt; JSON.Parser.Number.parse &quot;-hello&quot; {:error, {:unexpected_token, &quot;hello&quot;}} iex&gt; JSON.Parser.Number.parse &quot;129245&quot; {:ok, 129245, &quot;&quot;} iex&gt; JSON.Parser.Number.parse &quot;7.something&quot; {:ok, 7, &quot;.something&quot;} iex&gt; JSON.Parser.Number.parse &quot;7.4566something&quot; {:ok, 7.4566, &quot;something&quot;} iex&gt; JSON.Parser.Number.parse &quot;-88.22suffix&quot; {:ok, -88.22, &quot;suffix&quot;} iex&gt; JSON.Parser.Number.parse &quot;-12e4and then some&quot; {:ok, -1.2e+5, &quot;and then some&quot;} iex&gt; JSON.Parser.Number.parse &quot;7842490016E-12-and more&quot; {:ok, 7.842490016e-3, &quot;-and more&quot;}"},{"ref":"JSON.Parser.Object.html","title":"JSON.Parser.Object","type":"module","doc":"Implements a JSON Object Parser for Bitstring values"},{"ref":"JSON.Parser.Object.html#parse/1","title":"JSON.Parser.Object.parse/1","type":"function","doc":"parses a valid JSON object value, returns its elixir representation Examples iex&gt; JSON.Parser.Object.parse &quot;&quot; {:error, :unexpected_end_of_buffer} iex&gt; JSON.Parser.Object.parse &quot;face0ff&quot; {:error, {:unexpected_token, &quot;face0ff&quot;}} iex&gt; JSON.Parser.Object.parse &quot;[] &quot; {:error, {:unexpected_token, &quot;[] &quot;}} iex&gt; JSON.Parser.Object.parse &quot;[]&quot; {:error, {:unexpected_token, &quot;[]&quot;}} iex&gt; JSON.Parser.Object.parse &quot;[\\&quot;foo\\&quot;, 1, 2, 1.5] lala&quot; {:error, {:unexpected_token, &quot;[\\&quot;foo\\&quot;, 1, 2, 1.5] lala&quot;}} iex&gt; JSON.Parser.Object.parse &quot;{\\&quot;result\\&quot;: \\&quot;this will be a elixir result\\&quot;} lalal&quot; {:ok, Enum.into([{&quot;result&quot;, &quot;this will be a elixir result&quot;}], Map.new), &quot; lalal&quot;}"},{"ref":"JSON.Parser.String.html","title":"JSON.Parser.String","type":"module","doc":"Implements a JSON String Parser for Bitstring values"},{"ref":"JSON.Parser.String.html#parse/1","title":"JSON.Parser.String.parse/1","type":"function","doc":"parses a valid JSON string, returns its elixir representation Examples iex&gt; JSON.Parser.String.parse &quot;&quot; {:error, :unexpected_end_of_buffer} iex&gt; JSON.Parser.String.parse &quot;face0ff&quot; {:error, {:unexpected_token, &quot;face0ff&quot;}} iex&gt; JSON.Parser.String.parse &quot;-hello&quot; {:error, {:unexpected_token, &quot;-hello&quot;}} iex&gt; JSON.Parser.String.parse &quot;129245&quot; {:error, {:unexpected_token, &quot;129245&quot;}} iex&gt; JSON.Parser.String.parse &quot;\\&quot;7.something\\&quot;&quot; {:ok, &quot;7.something&quot;, &quot;&quot;} iex&gt; JSON.Parser.String.parse &quot;\\&quot;-88.22suffix\\&quot; foo bar&quot; {:ok, &quot;-88.22suffix&quot;, &quot; foo bar&quot;} iex&gt; JSON.Parser.String.parse &quot;\\&quot;star -&gt; \\\\u272d &lt;- star\\&quot;&quot; {:ok, &quot;star -&gt; ✭ &lt;- star&quot;, &quot;&quot;} iex&gt; JSON.Parser.String.parse &quot;\\&quot;\\\\u00df ist wunderbar\\&quot;&quot; {:ok, &quot;ß ist wunderbar&quot;, &quot;&quot;} iex&gt; JSON.Parser.String.parse &quot;\\&quot;Rafaëlla\\&quot; foo bar&quot; {:ok, &quot;Rafaëlla&quot;, &quot; foo bar&quot;} iex&gt; JSON.Parser.String.parse &quot;\\&quot;Éloise woot\\&quot; Éloise&quot; {:ok, &quot;Éloise woot&quot;, &quot; Éloise&quot;}"},{"ref":"JSON.Parser.Unicode.html","title":"JSON.Parser.Unicode","type":"module","doc":"Implements a JSON Unicode Parser for Bitstring values"},{"ref":"JSON.Parser.Unicode.html#parse/1","title":"JSON.Parser.Unicode.parse/1","type":"function","doc":"parses a valid chain of escaped unicode and returns the string representation, plus the remainder of the string Examples iex&gt; JSON.Parser.parse &quot;&quot; {:error, :unexpected_end_of_buffer} iex&gt; JSON.Parser.parse &quot;face0ff&quot; {:error, {:unexpected_token, &quot;face0ff&quot;}} iex&gt; JSON.Parser.parse &quot;-hello&quot; {:error, {:unexpected_token, &quot;-hello&quot;}}"},{"ref":"readme.html","title":"Elixir JSON","type":"extras","doc":"Elixir JSON This library provides a natively implemented JSON encoder and decoder for Elixir. All contributions are welcome. Before you install When dealing with smaller file.json ~ 14KB payloads, JSON v1 handles the processing consistently performant, with a much smaller deviation, and absolutely no real-world absolute performance differences with Jason. However, with often unusually large file.json &gt; 5MB payloads, and if the processing speed for those payloads is paramount to you (ie, processing them in a real-time manner vs using them in migration scripts or whatever), JSON v1 currently significantly slower when compared to Jason. Small payload bench/data/utf-8-unescaped.json &lt; 30KB benchmark results for JSON v1 and Jason As you can see below, both libraries handle &quot;regular&quot; small json payloads beautifully. JSON.decode calls while usually being a bit slower than their Jason counterparts, they are more consistently performant, with a much smaller deviation. So I would actually advise using JSON.decode and JSON.encode for smaller payloads. For JSON.encode vs Jason.encode, the difference is so minimal, it&#39;s not worth arguing about. LibraryAverageDeviationmedianminimummaximum JSON.decode13.35 ms±45.95%11.47 ms8.17 ms99.49 ms Jason.decode0.26 ms±246.84%0.170 ms0.150 ms64.35 ms JSON.encode1.32 ms±225.81%0.58 ms0.28 ms103.70 ms Jason.encode0.30 ms±316.71%0.163 ms0.147 ms82.68 ms Full benchee reports for bench/data/utf-8-unescaped.json &lt; 30KB: decode: https://bit.ly/2GVV8dy encode: https://bit.ly/2v5W0H0 Large payload bench/data/issue-90.json ~ 8MB benchmark results for JSON v1 and Jason However, with often unusually large file.json &gt; 5MB payloads, and if the processing speed for those payloads is paramount to you (ie, processing them in a real-time manner vs using them in migration scripts or whatever), then JSON v1 would not be the best choice when compared to Jason. LibraryAverageDeviationmedianminimummaximum JSON.decode8.93 s±5.71%8.96 s8.10 s9.57 s Jason.decode0.182 s±21.60%0.171 s0.139 s0.42 s JSON.encode5.51 s±18.10%5.24 s4.32 s7.36 s Jason.encode0.186 s±26.41%0.173 s0.122 s0.38 s Full benchee reports for bench/data/issue-90.json ~ 8MB: decode: https://bit.ly/2HxReEP encode: https://bit.ly/2HuR0OM Plan of action for Elixir JSON v2 I am currently working on a solution for this problem in JSON v2. You can follow the process here: https://github.com/cblage/elixir-json/pull/52 Interim Solution To processes these large payloads adding the Jason lib to your dependencies (without hopefully removing JSON for the smaller payloads :sweat_smile:): Jason@Hex.pm: http://hex.pm/packages/jason Jason@GitHub: https://github.com/michalmuskala/jason After installing Jason, you then use JSON.decode and JSON.encode for small your small 30KB range json payloads due to the reasons mentioned above. While Elixir JSON v2 is not ready to processs the bigger &gt;5MB json payloads in time-sensitive operations, you go for Jason.decode and Jason.encode. Thanks for the comprehension, Carlos Brito Lage"},{"ref":"readme.html#example","title":"Elixir JSON - Example","type":"extras","doc":"[ {:cowboy, &quot;~&gt; 1.0.0&quot;}, {:plug, &quot;~&gt; 1.0&quot;}, {:json, &quot;~&gt; 1.2&quot;}, {:jason, &quot;~&gt; 1.0&quot;}, ] You can find its documentation here: https://hexdocs.pm/jason/readme.html Installing Simply add {:json, &quot;~&gt; 1.2&quot;} to your project&#39;s mix.exs file, in the dependencies list and run mix deps.get json."},{"ref":"readme.html#example-for-a-project-that-already-uses-plug","title":"Elixir JSON - Example for a project that already uses Plug:","type":"extras","doc":"[ {:cowboy, &quot;~&gt; 1.0.0&quot;}, {:plug, &quot;~&gt; 1.0&quot;}, {:json, &quot;~&gt; 1.2&quot;}, ] Usage Encoding an Elixir type @doc &quot; JSON encode an Elixir list &quot; list = [key: &quot;this will be a value&quot;] is_list(list) # true list[:key] # &quot;this will be a value&quot; {status, result} = JSON.encode(list) # {:ok, &quot;{\\&quot;key\\&quot;:\\&quot;this will be a value\\&quot;}&quot;} String.length(result) # 41 Decoding a list from a string that contains JSON @doc &quot; JSON decode a string into an Elixir list &quot; json_input = &quot;{\\&quot;key\\&quot;:\\&quot;this will be a value\\&quot;}&quot; {status, list} = JSON.decode(json_input) {:ok, %{&quot;key&quot; =&gt; &quot;this will be a value&quot;}} list[:key] # nil list[&quot;key&quot;] # &quot;this will be a value&quot; At any time, you can turn on verbose logging for this library only. To do so, head to config file of your application and add below lines: use Mix.Config config :logger, level: :debug config :json, log_level: :debug Note that, changing only :logger level to :info, :warn or :error will silent :json too. License The Elixir JSON library is available under the BSD 3-Clause aka &quot;BSD New&quot; license"}]